package com.example.reconocimientonubes;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;

import android.app.Activity;
import android.content.res.AssetFileDescriptor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.widget.ImageView;

public class Foto extends Activity{
	private ImageView imagen_final;
	private ImageView imagen_final2;
	int[] contorno;
	int[] nombres;
	double[][] mapa_distancia_ordenada;
	String texto;
	String linea;
	//double prueba;
	int sumNubeContorno=0;
	ArrayList<Double> euclidea = new ArrayList<Double>();
	ArrayList<String> imagenes = new ArrayList<String>();
	List<List<Double>> mapa_distancia = new ArrayList<List<Double>>();
	int contadoresA = -1;
	//int tamao=30000;
	double convertirDouble = 0;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.foto);
		ImageView iv = (ImageView)findViewById(R.id.ImageViewOriginal);
	    iv.setImageBitmap((Bitmap) this.getIntent().getExtras().getParcelable("imagen"));
	    
	    //Canny	    
	    //create the detector
        CannyEdgeDetector detector = new CannyEdgeDetector();
        //adjust its parameters as desired
        detector.setLowThreshold(0.5f);
        detector.setHighThreshold(1f);

        //apply it to an image
        detector.setSourceImage((Bitmap) this.getIntent().getExtras().getParcelable("imagen"));
        detector.process();
        Bitmap edges = detector.getEdgesImage();
        int[] pixels = new int[edges.getHeight()*edges.getWidth()];
        edges.getPixels(pixels, 0, edges.getWidth(), 0, 0, edges.getWidth(), edges.getHeight());
        //Mostramos imagen contorno Canny
        //imagen_final = (ImageView)findViewById(R.id.ImageView00);
        //imagen_final.setImageBitmap(edges);
        //La imagen CANNY me la da correctamente
        //Leemos matriz de Canny Edge Detector 
        contorno = detector.getData();
        /*for(int i=0;i<contorno.length;i++){
        	if(contorno[i] == -16777216){
        		contorno[i] = 0;
        	}else if (contorno[i] == -1){
        		contorno[i] = 1;
        	}
        }*/
        
        //Calculo sumatorio contorno nube
		for(int i=0;i<contorno.length;i++){
			sumNubeContorno= sumNubeContorno + contorno[i];
		}
		

        /* Leer distancias euclideas
         * Archivo en la SD Card */
        try
        {
            File ruta_sd = Environment.getExternalStorageDirectory();
            File f = new File(ruta_sd.getAbsolutePath(), "datos_euclidea.txt");
            BufferedReader fin = new BufferedReader(new InputStreamReader( new FileInputStream(f)),32768);
            while((texto=fin.readLine())!=null){
            	if(texto.equals("a")){
            		contadoresA++;
            		calculoDistancia(euclidea,contorno,sumNubeContorno,contadoresA);
            		
            	} else{
                	convertirDouble = Double.parseDouble(texto);
                	euclidea.add(convertirDouble);
            	}
            }
            
            mapa_distancia_ordenada=ordenarMapaDistancia(mapa_distancia);
            imagenes = nombresImagenes(mapa_distancia_ordenada);
            abrirImagenes(imagenes);
            
            
            fin.close();
        }
        catch (Exception ex)
        {
            Log.e("Ficheros", "Error al leer fichero desde tarjeta SD");
        } 
        

	
	}

	public double[][] ordenarMapaDistancia(List<List<Double>> mapa_distancia) {
        //ordenar mapa_distancia
        double[][] mapa_distancia_ordenada = new double[mapa_distancia.size()][2];
        for(int i=0;i<mapa_distancia.size();i++){
        	for(int j=0;j<2;j++){
        		mapa_distancia_ordenada[i][j]=mapa_distancia.get(i).get(j);
        	}
        }
        Arrays.sort(mapa_distancia_ordenada, new Comparator<double[]>() {
        	public int compare(double[] a1, double[] a2) {
        		return Double.valueOf(a1[0]).compareTo(Double.valueOf(a2[0])); //X coord
        		//return Double.valueOf(a1[1]).compareTo(Double.valueOf(a2[1])); // Y coord
        	}
        });
        return mapa_distancia_ordenada;
	}
	
	private void calculoDistancia(ArrayList<Double> euclidea, int[] contorno, int sumNubecontorno, int posicionA) {
		double distancia_i=0;
		ArrayList<Double> aux = new ArrayList<Double>();
		
		for(int i=0;i<euclidea.size();i++){
			distancia_i+=((contorno[i] * (euclidea.get(i)))/sumNubecontorno);
			//
		}
		//distancia_i=distancia_i/sumNubecontorno;
		
		aux.add(distancia_i);
	    aux.add((double) posicionA);
		mapa_distancia.add(aux);
		euclidea.clear();
	}
	
	//Guardamos los nombres de las 5 imagenes mas parecidas a la de origen (camara o galeria)
	private ArrayList<String> nombresImagenes(double[][] mapa_distancia_ordenada) {
		ArrayList<String> leerimagenes = new ArrayList<String>();
		//int[] nombres = new int[5];
		int[] nombres = new int[5];
		for(int i=0;i<nombres.length;i++){
			nombres[i] = ((int)mapa_distancia_ordenada[i][1]);
		}
		
        /* Leer fichero de nombres imagenes
         * Archivo en la SD Card */
        try
        {
        	File ruta_sd = Environment.getExternalStorageDirectory();
            File f = new File(ruta_sd.getAbsolutePath(),"nombres.txt");
            BufferedReader fin = new BufferedReader(new InputStreamReader( new FileInputStream(f)));
            while((linea=fin.readLine())!=null){
            	leerimagenes.add(linea);
            }
            
            for(int i=0;i<nombres.length;i++){
            	imagenes.add(leerimagenes.get(nombres[3]));           	
            }
                      
        }
  
        catch (Exception ex)
        {
            Log.e("Ficheros", "Error al leer fichero desde recurso raw");
        }      	
        
        return imagenes;
	}
	
	private void abrirImagenes(ArrayList<String> imagenes) {
		//String nombreImagen;
		//nombreImagen="R.id.ImageView"+0;
		String PATH_IMAGEN = "/TFC_Andres/"+imagenes.get(0);
		String imagePath = Environment.getExternalStorageDirectory().toString() + PATH_IMAGEN;
		File imageFile = new File(imagePath);
		//Leer imagen
		Bitmap bitmap = null;
		bitmap = BitmapFactory.decodeFile(imageFile.getAbsolutePath());   
		for(int i=0;i<imagenes.size();i++){
			switch(i){
			case 0: 
			imagen_final = (ImageView) findViewById(R.id.ImageView00);
            imagen_final.setImageBitmap(bitmap);
            break;
			case 1:     
			PATH_IMAGEN = "/TFC_Andres/"+imagenes.get(1);
			imagePath = Environment.getExternalStorageDirectory().toString() + PATH_IMAGEN;
			imageFile = new File(imagePath);
			bitmap = BitmapFactory.decodeFile(imageFile.getAbsolutePath()); 
			imagen_final2 = (ImageView) findViewById(R.id.ImageView01);
            imagen_final2.setImageBitmap(bitmap);
            break;
			/*case 2:             
			imagen_final = (ImageView) findViewById(R.id.ImageView02);
            imagen_final.setImageBitmap(bitmap);
            break;
			case 3:             
			imagen_final = (ImageView) findViewById(R.id.ImageView03);
            imagen_final.setImageBitmap(bitmap);
            break;
			case 4:             
			imagen_final = (ImageView) findViewById(R.id.ImageView04);
            imagen_final.setImageBitmap(bitmap);
            break;*/
			}
			
        }

	}
}



        
        
        
        
       